import { Player, Entity, Dimension, world, ScoreboardObjective } from "@minecraft/server";
import { ModalFormData } from "@minecraft/server-ui";

function team_msg(player: Player) {
    let player_with_team_arr = new Array<string>
    let red_t = 0
    let blue_t = 0
    let no_t = 0
    world.getAllPlayers().forEach(p => {
        if (if_in('team_red', p.getTags())) {
            player_with_team_arr.push('§c' + p.nameTag + '§r')
            red_t ++
        } else if (if_in('team_blue', p.getTags())) {
            player_with_team_arr.push('§b' + p.nameTag + '§r')
            blue_t ++
        } else {
            player_with_team_arr.push('§r' + p.nameTag + '§r')
            no_t ++
        }
    })
    let team_msg = ''
    player_with_team_arr.forEach(p=>{
        team_msg += p + ' '
    })
    mult_run_command(player, [
        'tellraw @s { "rawtext" : [ { "translate" : "text.dec:crystal_perspective_book_team_list.name" } ] }',
        'tellraw @s { "rawtext" : [ { "text": "§r' + team_msg.slice(0, -1) + '§r----§l§c' + String(red_t) + '§r:§l§b' + String(blue_t) + '§r:§l' + String(no_t) + '" } ] }'
    ])
}

function in_range(input: number, min: number, max: number) {
    if (min <= input && input <= max) {
        return true
    } else {
        return false
    }
}

class MathUtil {
    static randomInteger(min: number, max: number) {
        let length = Math.floor(Math.random() * (max - min + 1));
        return min + length;
    }
}

function get_score(sb_id: string, name: string) {
    let p = NaN;
    (<ScoreboardObjective>world.scoreboard.getObjective(sb_id)).getScores().forEach(f => {
        if (f.participant.displayName == name) {
            p = f.score
        }
    })
    return p
}

function mult_run_command(exe: Player | Entity | Dimension, commands: Array<string>, times: number = 1) {
    while (times >= 1) {
        for (let c of commands) {
            exe.runCommandAsync(c).catch(e => console.warn(e))
        }
        times = times - 1
    }
}

function if_in(ele: any, lis: Array<any>) {
    let test = false
    for (let l of lis) {
        if (l == ele) {
            test = true
            break
        }
    }
    return test
}

export class crystal_perspective_book {
    constructor() { }
    static crystal_perspective_book_index(player: Player) {
        let tags = player.getTags()
        let index = new ModalFormData()
        if (get_score('global', 'game_state') == 0 || isNaN(get_score('global', 'game_state')) || (if_in('team_red', tags) == false && if_in('team_blue', tags) == false)) {
            index.dropdown('text.dec:crystal_perspective_book_choose_team.name', [
                'text.dec:crystal_perspective_book_choose_team_blue.name',
                'text.dec:crystal_perspective_book_choose_team_red.name'
            ], MathUtil.randomInteger(0, 1))
            index.show(player).then(t => {
                if (t.canceled) {
                    team_msg(player)
                    return
                }
                if (t.formValues![0] == 0) {
                    mult_run_command(player, [
                        'tellraw @a { "rawtext" : [ { "translate" : "text.dec:crystal_perspective_book_join_blue_team.name","with": { "rawtext": [ { "selector": "@s" } ] } } ] }',
                        "tag @s[tag=team_red] remove team_red",
                        "tag @s[tag=!team_blue] add team_blue"
                    ])
                } else if (t.formValues![0] == 1) {
                    mult_run_command(player, [
                        'tellraw @a { "rawtext" : [ { "translate" : "text.dec:crystal_perspective_book_join_red_team.name","with": { "rawtext": [ { "selector": "@s" } ] } } ] }',
                        "tag @s[tag=team_blue] remove team_blue",
                        "tag @s[tag=!team_red] add team_red"
                    ])
                }
            })
        } else if (get_score('global', 'game_state') == 1 && ((if_in('team_red', tags) || if_in('team_blue', tags)))) {
            index.dropdown('text.dec:crystal_perspective_book_action.name', [
                'text.dec:crystal_perspective_book_team_list.name',
                'text.dec:crystal_perspective_book_suicide.name'
            ], 0)
            index.show(player).then(t => {
                if (t.canceled) {
                    return
                } else if (t.formValues![0] == 0) {
                    team_msg(player)
                } else if (t.formValues![0] == 1) {
                    player.runCommandAsync('kill @s')
                }
            })
        }
    }
    static crystal_perspective_book_tell(player: Player) {
        let c_msg = ''
        let blue_oc = 0
        let red_oc = 0
        let no_oc = 0
        for (let c of world.getDimension('overworld').getEntities(
            {
                type: 'dec:conquer_crystal'
            }
        )) {
            let c_color = '§f§l'
            if (in_range(get_score('global', c.id), -101, -70)) {
                c_color = '§c§l'
                red_oc++
            } else if (in_range(get_score('global', c.id), 70, 101)) {
                c_color = '§b§l'
                blue_oc++
            } else {
                no_oc++
            }
            c_msg = c_msg + '§r\n' + c_color + c.nameTag
        }
        c_msg = c_msg.slice(3)
        c_msg = c_msg + '\n----'
        let s_msg = ''
        if (if_in('team_blue', player.getTags())) {
            s_msg = '§b§lBlueTeam(you) ' + String(get_score('team_score', '§b§lBlueTeam')) + ' §c§lRedTeam(enemy) ' + String(get_score('team_score', '§c§lRedTeam'))
            c_msg = c_msg + '§b§l' + String(blue_oc) + '§r:§c§l' + String(red_oc) + '§r:§l' + String(no_oc)
        } else if (if_in('team_red', player.getTags())) {
            s_msg = '§c§lRedTeam(you) ' + String(get_score('team_score', '§c§lRedTeam')) + ' §b§lBlueTeam(enemy) ' + String(get_score('team_score', '§b§lBlueTeam'))
            c_msg = c_msg + '§c§l' + String(red_oc) + '§r:§b§l' + String(blue_oc) + '§r:§l' + String(no_oc)
        } else {
            s_msg = '§c§lRedTeam ' + String(get_score('team_score', '§c§lRedTeam')) + ' §b§lBlueTeam ' + String(get_score('team_score', '§b§lBlueTeam'))
            c_msg = c_msg + '§c§l' + String(red_oc) + '§r:§b§l' + String(blue_oc) + '§r:§l' + String(no_oc)
        }
        player.runCommandAsync('tellraw @s { "rawtext" : [ { "text": "§r\n' + c_msg + '\n' + s_msg + '" } ] }')
    }
}